Index: src/molecules.cpp
===================================================================
--- src/molecules.cpp	(revision 8c54a3b5f6bdf770309a91dff75fb62f47d91b6d)
+++ src/molecules.cpp	(revision 0dbddc24a89f547aa564634e7647f87ec8ce9700)
@@ -1985,184 +2680,184 @@
 MoleculeLeafClass * molecule::DepthFirstSearchAnalysis(ofstream *out, class StackClass<bond *> *&BackEdgeStack)
 {
-	class StackClass<atom *> *AtomStack = new StackClass<atom *>(AtomCount);
-	BackEdgeStack = new StackClass<bond *> (BondCount);
-	MoleculeLeafClass *SubGraphs = new MoleculeLeafClass(NULL);
-	MoleculeLeafClass *LeafWalker = SubGraphs;
-	int CurrentGraphNr = 0, OldGraphNr;
-	int ComponentNumber = 0;
-	atom *Walker = NULL, *OtherAtom = NULL, *Root = start->next;
-	bond *Binder = NULL;
-	bool BackStepping = false;
-
-	*out << Verbose(0) << "Begin of DepthFirstSearchAnalysis" << endl;
-
-	ResetAllBondsToUnused();
-	ResetAllAtomNumbers();
-	InitComponentNumbers();
-	BackEdgeStack->ClearStack();
-	while (Root != end) { // if there any atoms at all
-		// (1) mark all edges unused, empty stack, set atom->GraphNr = 0 for all
-		AtomStack->ClearStack();
-
-		// put into new subgraph molecule and add this to list of subgraphs
-		LeafWalker = new MoleculeLeafClass(LeafWalker);
-		LeafWalker->Leaf = new molecule(elemente);
-		LeafWalker->Leaf->AddCopyAtom(Root);
-
-		OldGraphNr = CurrentGraphNr;
-		Walker = Root;
-		do { // (10)
-			do { // (2) set number and Lowpoint of Atom to i, increase i, push current atom
-				if (!BackStepping) { // if we don't just return from (8)
-					Walker->GraphNr = CurrentGraphNr;
-					Walker->LowpointNr = CurrentGraphNr;
-					*out << Verbose(1) << "Setting Walker[" << Walker->Name << "]'s number to " << Walker->GraphNr << " with Lowpoint " << Walker->LowpointNr << "." << endl;
-					AtomStack->Push(Walker);
-					CurrentGraphNr++;
-				}
-				do { // (3) if Walker has no unused egdes, go to (5)
-					BackStepping = false; // reset backstepping flag for (8)
-					if (Binder == NULL) // if we don't just return from (11), Binder is already set to next unused
-						Binder = FindNextUnused(Walker);
-					if (Binder == NULL)
-						break;
-					*out << Verbose(2) << "Current Unused Bond is " << *Binder << "." << endl;
-					// (4) Mark Binder used, ...
-					Binder->MarkUsed(black);
-					OtherAtom = Binder->GetOtherAtom(Walker);
-					*out << Verbose(2) << "(4) OtherAtom is " << OtherAtom->Name << "." << endl;
-					if (OtherAtom->GraphNr != -1) {
-						// (4a) ... if "other" atom has been visited (GraphNr != 0), set lowpoint to minimum of both, go to (3)
-						Binder->Type = BackEdge;
-						BackEdgeStack->Push(Binder);
-						Walker->LowpointNr = ( Walker->LowpointNr < OtherAtom->GraphNr ) ? Walker->LowpointNr : OtherAtom->GraphNr;
-						*out << Verbose(3) << "(4a) Visited: Setting Lowpoint of Walker[" << Walker->Name << "] to " << Walker->LowpointNr << "." << endl;
-					} else {
-						// (4b) ... otherwise set OtherAtom as Ancestor of Walker and Walker as OtherAtom, go to (2)
-						Binder->Type = TreeEdge;
-						OtherAtom->Ancestor = Walker;
-						Walker = OtherAtom;
-						*out << Verbose(3) << "(4b) Not Visited: OtherAtom[" << OtherAtom->Name << "]'s Ancestor is now " << OtherAtom->Ancestor->Name << ", Walker is OtherAtom " << OtherAtom->Name << "." << endl;
-						break;
-					}
-					Binder = NULL;
-				} while (1);	// (3)
-				if (Binder == NULL) {
-					*out << Verbose(2) << "No more Unused Bonds." << endl;
-					break;
-				} else
-					Binder = NULL;
-			} while (1);	// (2)
-
-			// if we came from backstepping, yet there were no more unused bonds, we end up here with no Ancestor, because Walker is Root! Then we are finished!
-			if ((Walker == Root) && (Binder == NULL))
-				break;
-
-			// (5) if Ancestor of Walker is ...
-			*out << Verbose(1) << "(5) Number of Walker[" << Walker->Name << "]'s Ancestor[" << Walker->Ancestor->Name << "] is " << Walker->Ancestor->GraphNr << "." << endl;
-			if (Walker->Ancestor->GraphNr != Root->GraphNr) {
-				// (6)	(Ancestor of Walker is not Root)
-				if (Walker->LowpointNr < Walker->Ancestor->GraphNr) {
-					// (6a) set Ancestor's Lowpoint number to minimum of of its Ancestor and itself, go to Step(8)
-					Walker->Ancestor->LowpointNr = (Walker->Ancestor->LowpointNr < Walker->LowpointNr) ? Walker->Ancestor->LowpointNr : Walker->LowpointNr;
-					*out << Verbose(2) << "(6) Setting Walker[" << Walker->Name << "]'s Ancestor[" << Walker->Ancestor->Name << "]'s Lowpoint to " << Walker->Ancestor->LowpointNr << "." << endl;
-				} else {
-					// (7) (Ancestor of Walker is a separating vertex, remove all from stack till Walker (including), these and Ancestor form a component
-					Walker->Ancestor->SeparationVertex = true;
-					*out << Verbose(2) << "(7) Walker[" << Walker->Name << "]'s Ancestor[" << Walker->Ancestor->Name << "]'s is a separating vertex, creating component." << endl;
-					SetNextComponentNumber(Walker->Ancestor, ComponentNumber);
-					*out << Verbose(3) << "(7) Walker[" << Walker->Name << "]'s Ancestor's Compont is " << ComponentNumber << "." << endl;
-					SetNextComponentNumber(Walker, ComponentNumber);
-					*out << Verbose(3) << "(7) Walker[" << Walker->Name << "]'s Compont is " << ComponentNumber << "." << endl;
-					do {
-						OtherAtom = AtomStack->PopLast();
-						LeafWalker->Leaf->AddCopyAtom(OtherAtom);
-						SetNextComponentNumber(OtherAtom, ComponentNumber);
-						*out << Verbose(3) << "(7) Other[" << OtherAtom->Name << "]'s Compont is " << ComponentNumber << "." << endl;
-					} while (OtherAtom != Walker);
-					ComponentNumber++;
-				}
-				// (8) Walker becomes its Ancestor, go to (3)
-				*out << Verbose(2) << "(8) Walker[" << Walker->Name << "] is now its Ancestor " << Walker->Ancestor->Name << ", backstepping. " << endl;
-				Walker = Walker->Ancestor;
-				BackStepping = true;
-			}
-			if (!BackStepping) {	// coming from (8) want to go to (3)
-				// (9) remove all from stack till Walker (including), these and Root form a component
-				AtomStack->Output(out);
-				SetNextComponentNumber(Root, ComponentNumber);
-				*out << Verbose(3) << "(9) Root[" << Root->Name << "]'s Component is " << ComponentNumber << "." << endl;
-				SetNextComponentNumber(Walker, ComponentNumber);
-				*out << Verbose(3) << "(9) Walker[" << Walker->Name << "]'s Component is " << ComponentNumber << "." << endl;
-				do {
-					OtherAtom = AtomStack->PopLast();
-					LeafWalker->Leaf->AddCopyAtom(OtherAtom);
-					SetNextComponentNumber(OtherAtom, ComponentNumber);
-					*out << Verbose(3) << "(7) Other[" << OtherAtom->Name << "]'s Compont is " << ComponentNumber << "." << endl;
-				} while (OtherAtom != Walker);
-				ComponentNumber++;
-
-				// (11) Root is separation vertex,	set Walker to Root and go to (4)
-				Walker = Root;
-				Binder = FindNextUnused(Walker);
-				*out << Verbose(1) << "(10) Walker is Root[" << Root->Name << "], next Unused Bond is " << Binder << "." << endl;
-				if (Binder != NULL) { // Root is separation vertex
-					*out << Verbose(1) << "(11) Root is a separation vertex." << endl;
-					Walker->SeparationVertex = true;
-				}
-			}
-		} while ((BackStepping) || (Binder != NULL)); // (10) halt only if Root has no unused edges
-
-		// From OldGraphNr to CurrentGraphNr ranges an disconnected subgraph
-		*out << Verbose(0) << "Disconnected subgraph ranges from " << OldGraphNr << " to " << CurrentGraphNr << "." << endl;
-		LeafWalker->Leaf->Output(out);
-		*out << endl;
-
-		// step on to next root
-		while ((Root != end) && (Root->GraphNr != -1)) {
-			//*out << Verbose(1) << "Current next subgraph root candidate is " << Root->Name << "." << endl;
-			if (Root->GraphNr != -1) // if already discovered, step on
-				Root = Root->next;
-		}
-	}
-	// set cyclic bond criterium on "same LP" basis
-	Binder = first;
-	while(Binder->next != last) {
-		Binder = Binder->next;
-		if (Binder->rightatom->LowpointNr == Binder->leftatom->LowpointNr) { // cyclic ??
-			Binder->Cyclic = true;
-			NoCyclicBonds++;
-		}
-	}
-
-
-	*out << Verbose(1) << "Final graph info for each atom is:" << endl;
-	Walker = start;
-	while (Walker->next != end) {
-		Walker = Walker->next;
-		*out << Verbose(2) << "Atom " << Walker->Name << " is " << ((Walker->SeparationVertex) ? "a" : "not a") << " separation vertex, components are ";
-		OutputComponentNumber(out, Walker);
-		*out << " with Lowpoint " << Walker->LowpointNr << " and Graph Nr. " << Walker->GraphNr << "." << endl;
-	}
-
-	*out << Verbose(1) << "Final graph info for each bond is:" << endl;
-	Binder = first;
-	while(Binder->next != last) {
-		Binder = Binder->next;
-		*out << Verbose(2) << ((Binder->Type == TreeEdge) ? "TreeEdge " : "BackEdge ") << *Binder << ": <";
-		*out << ((Binder->leftatom->SeparationVertex) ? "SP," : "") << "L" << Binder->leftatom->LowpointNr << " G" << Binder->leftatom->GraphNr << " Comp.";
-		OutputComponentNumber(out, Binder->leftatom);
-		*out << " ===	";
-		*out << ((Binder->rightatom->SeparationVertex) ? "SP," : "") << "L" << Binder->rightatom->LowpointNr << " G" << Binder->rightatom->GraphNr << " Comp.";
-		OutputComponentNumber(out, Binder->rightatom);
-		*out << ">." << endl;
-		if (Binder->Cyclic) // cyclic ??
-			*out << Verbose(3) << "Lowpoint at each side are equal: CYCLIC!" << endl;
-	}
-
-	// free all and exit
-	delete(AtomStack);
-	*out << Verbose(0) << "End of DepthFirstSearchAnalysis" << endl;
-	return SubGraphs;
+  class StackClass<atom *> *AtomStack = new StackClass<atom *>(AtomCount);
+  BackEdgeStack = new StackClass<bond *> (BondCount);
+  MoleculeLeafClass *SubGraphs = new MoleculeLeafClass(NULL);
+  MoleculeLeafClass *LeafWalker = SubGraphs;
+  int CurrentGraphNr = 0, OldGraphNr;
+  int ComponentNumber = 0;
+  atom *Walker = NULL, *OtherAtom = NULL, *Root = start->next;
+  bond *Binder = NULL;
+  bool BackStepping = false;
+
+  *out << Verbose(0) << "Begin of DepthFirstSearchAnalysis" << endl;
+
+  ResetAllBondsToUnused();
+  ResetAllAtomNumbers();
+  InitComponentNumbers();
+  BackEdgeStack->ClearStack();
+  while (Root != end) { // if there any atoms at all
+    // (1) mark all edges unused, empty stack, set atom->GraphNr = 0 for all
+    AtomStack->ClearStack();
+
+    // put into new subgraph molecule and add this to list of subgraphs
+    LeafWalker = new MoleculeLeafClass(LeafWalker);
+    LeafWalker->Leaf = new molecule(elemente);
+    LeafWalker->Leaf->AddCopyAtom(Root);
+
+    OldGraphNr = CurrentGraphNr;
+    Walker = Root;
+    do { // (10)
+      do { // (2) set number and Lowpoint of Atom to i, increase i, push current atom
+        if (!BackStepping) { // if we don't just return from (8)
+          Walker->GraphNr = CurrentGraphNr;
+          Walker->LowpointNr = CurrentGraphNr;
+          *out << Verbose(1) << "Setting Walker[" << Walker->Name << "]'s number to " << Walker->GraphNr << " with Lowpoint " << Walker->LowpointNr << "." << endl;
+          AtomStack->Push(Walker);
+          CurrentGraphNr++;
+        }
+        do { // (3) if Walker has no unused egdes, go to (5)
+          BackStepping = false; // reset backstepping flag for (8)
+          if (Binder == NULL) // if we don't just return from (11), Binder is already set to next unused
+            Binder = FindNextUnused(Walker);
+          if (Binder == NULL)
+            break;
+          *out << Verbose(2) << "Current Unused Bond is " << *Binder << "." << endl;
+          // (4) Mark Binder used, ...
+          Binder->MarkUsed(black);
+          OtherAtom = Binder->GetOtherAtom(Walker);
+          *out << Verbose(2) << "(4) OtherAtom is " << OtherAtom->Name << "." << endl;
+          if (OtherAtom->GraphNr != -1) {
+            // (4a) ... if "other" atom has been visited (GraphNr != 0), set lowpoint to minimum of both, go to (3)
+            Binder->Type = BackEdge;
+            BackEdgeStack->Push(Binder);
+            Walker->LowpointNr = ( Walker->LowpointNr < OtherAtom->GraphNr ) ? Walker->LowpointNr : OtherAtom->GraphNr;
+            *out << Verbose(3) << "(4a) Visited: Setting Lowpoint of Walker[" << Walker->Name << "] to " << Walker->LowpointNr << "." << endl;
+          } else {
+            // (4b) ... otherwise set OtherAtom as Ancestor of Walker and Walker as OtherAtom, go to (2)
+            Binder->Type = TreeEdge;
+            OtherAtom->Ancestor = Walker;
+            Walker = OtherAtom;
+            *out << Verbose(3) << "(4b) Not Visited: OtherAtom[" << OtherAtom->Name << "]'s Ancestor is now " << OtherAtom->Ancestor->Name << ", Walker is OtherAtom " << OtherAtom->Name << "." << endl;
+            break;
+          }
+          Binder = NULL;
+        } while (1);  // (3)
+        if (Binder == NULL) {
+          *out << Verbose(2) << "No more Unused Bonds." << endl;
+          break;
+        } else
+          Binder = NULL;
+      } while (1);  // (2)
+
+      // if we came from backstepping, yet there were no more unused bonds, we end up here with no Ancestor, because Walker is Root! Then we are finished!
+      if ((Walker == Root) && (Binder == NULL))
+        break;
+
+      // (5) if Ancestor of Walker is ...
+      *out << Verbose(1) << "(5) Number of Walker[" << Walker->Name << "]'s Ancestor[" << Walker->Ancestor->Name << "] is " << Walker->Ancestor->GraphNr << "." << endl;
+      if (Walker->Ancestor->GraphNr != Root->GraphNr) {
+        // (6)  (Ancestor of Walker is not Root)
+        if (Walker->LowpointNr < Walker->Ancestor->GraphNr) {
+          // (6a) set Ancestor's Lowpoint number to minimum of of its Ancestor and itself, go to Step(8)
+          Walker->Ancestor->LowpointNr = (Walker->Ancestor->LowpointNr < Walker->LowpointNr) ? Walker->Ancestor->LowpointNr : Walker->LowpointNr;
+          *out << Verbose(2) << "(6) Setting Walker[" << Walker->Name << "]'s Ancestor[" << Walker->Ancestor->Name << "]'s Lowpoint to " << Walker->Ancestor->LowpointNr << "." << endl;
+        } else {
+          // (7) (Ancestor of Walker is a separating vertex, remove all from stack till Walker (including), these and Ancestor form a component
+          Walker->Ancestor->SeparationVertex = true;
+          *out << Verbose(2) << "(7) Walker[" << Walker->Name << "]'s Ancestor[" << Walker->Ancestor->Name << "]'s is a separating vertex, creating component." << endl;
+          SetNextComponentNumber(Walker->Ancestor, ComponentNumber);
+          *out << Verbose(3) << "(7) Walker[" << Walker->Name << "]'s Ancestor's Compont is " << ComponentNumber << "." << endl;
+          SetNextComponentNumber(Walker, ComponentNumber);
+          *out << Verbose(3) << "(7) Walker[" << Walker->Name << "]'s Compont is " << ComponentNumber << "." << endl;
+          do {
+            OtherAtom = AtomStack->PopLast();
+            LeafWalker->Leaf->AddCopyAtom(OtherAtom);
+            SetNextComponentNumber(OtherAtom, ComponentNumber);
+            *out << Verbose(3) << "(7) Other[" << OtherAtom->Name << "]'s Compont is " << ComponentNumber << "." << endl;
+          } while (OtherAtom != Walker);
+          ComponentNumber++;
+        }
+        // (8) Walker becomes its Ancestor, go to (3)
+        *out << Verbose(2) << "(8) Walker[" << Walker->Name << "] is now its Ancestor " << Walker->Ancestor->Name << ", backstepping. " << endl;
+        Walker = Walker->Ancestor;
+        BackStepping = true;
+      }
+      if (!BackStepping) {  // coming from (8) want to go to (3)
+        // (9) remove all from stack till Walker (including), these and Root form a component
+        AtomStack->Output(out);
+        SetNextComponentNumber(Root, ComponentNumber);
+        *out << Verbose(3) << "(9) Root[" << Root->Name << "]'s Component is " << ComponentNumber << "." << endl;
+        SetNextComponentNumber(Walker, ComponentNumber);
+        *out << Verbose(3) << "(9) Walker[" << Walker->Name << "]'s Component is " << ComponentNumber << "." << endl;
+        do {
+          OtherAtom = AtomStack->PopLast();
+          LeafWalker->Leaf->AddCopyAtom(OtherAtom);
+          SetNextComponentNumber(OtherAtom, ComponentNumber);
+          *out << Verbose(3) << "(7) Other[" << OtherAtom->Name << "]'s Compont is " << ComponentNumber << "." << endl;
+        } while (OtherAtom != Walker);
+        ComponentNumber++;
+
+        // (11) Root is separation vertex,  set Walker to Root and go to (4)
+        Walker = Root;
+        Binder = FindNextUnused(Walker);
+        *out << Verbose(1) << "(10) Walker is Root[" << Root->Name << "], next Unused Bond is " << Binder << "." << endl;
+        if (Binder != NULL) { // Root is separation vertex
+          *out << Verbose(1) << "(11) Root is a separation vertex." << endl;
+          Walker->SeparationVertex = true;
+        }
+      }
+    } while ((BackStepping) || (Binder != NULL)); // (10) halt only if Root has no unused edges
+
+    // From OldGraphNr to CurrentGraphNr ranges an disconnected subgraph
+    *out << Verbose(0) << "Disconnected subgraph ranges from " << OldGraphNr << " to " << CurrentGraphNr << "." << endl;
+    LeafWalker->Leaf->Output(out);
+    *out << endl;
+
+    // step on to next root
+    while ((Root != end) && (Root->GraphNr != -1)) {
+      //*out << Verbose(1) << "Current next subgraph root candidate is " << Root->Name << "." << endl;
+      if (Root->GraphNr != -1) // if already discovered, step on
+        Root = Root->next;
+    }
+  }
+  // set cyclic bond criterium on "same LP" basis
+  Binder = first;
+  while(Binder->next != last) {
+    Binder = Binder->next;
+    if (Binder->rightatom->LowpointNr == Binder->leftatom->LowpointNr) { // cyclic ??
+      Binder->Cyclic = true;
+      NoCyclicBonds++;
+    }
+  }
+
+
+  *out << Verbose(1) << "Final graph info for each atom is:" << endl;
+  Walker = start;
+  while (Walker->next != end) {
+    Walker = Walker->next;
+    *out << Verbose(2) << "Atom " << Walker->Name << " is " << ((Walker->SeparationVertex) ? "a" : "not a") << " separation vertex, components are ";
+    OutputComponentNumber(out, Walker);
+    *out << " with Lowpoint " << Walker->LowpointNr << " and Graph Nr. " << Walker->GraphNr << "." << endl;
+  }
+
+  *out << Verbose(1) << "Final graph info for each bond is:" << endl;
+  Binder = first;
+  while(Binder->next != last) {
+    Binder = Binder->next;
+    *out << Verbose(2) << ((Binder->Type == TreeEdge) ? "TreeEdge " : "BackEdge ") << *Binder << ": <";
+    *out << ((Binder->leftatom->SeparationVertex) ? "SP," : "") << "L" << Binder->leftatom->LowpointNr << " G" << Binder->leftatom->GraphNr << " Comp.";
+    OutputComponentNumber(out, Binder->leftatom);
+    *out << " ===  ";
+    *out << ((Binder->rightatom->SeparationVertex) ? "SP," : "") << "L" << Binder->rightatom->LowpointNr << " G" << Binder->rightatom->GraphNr << " Comp.";
+    OutputComponentNumber(out, Binder->rightatom);
+    *out << ">." << endl;
+    if (Binder->Cyclic) // cyclic ??
+      *out << Verbose(3) << "Lowpoint at each side are equal: CYCLIC!" << endl;
+  }
+
+  // free all and exit
+  delete(AtomStack);
+  *out << Verbose(0) << "End of DepthFirstSearchAnalysis" << endl;
+  return SubGraphs;
 };
 
